<?xml version = "1.0" encoding = "UTF-8"?>
<sch:schema xmlns = "http://www.w3.org/2001/XMLSchema" xmlns:sch = "http://www.ascc.net/xml/schematron" xmlns:xsd = "http://www.w3.org/2001/XMLSchema" xmlns:xsi = "http://www.w3.org/2001/XMLSchema-instance" xsi:schemaLocation = "http://www.ascc.net/xml/schematron schematron-1.5.xsd">
	<sch:title>Controlled vocabulary validation</sch:title>

 	<!-- The input is assumed to be a valid W3C XML Schema. -->
	<!-- This just checks that it is also a valid           -->
	<!-- vocabulary Schema.                                 -->

	<sch:pattern name = "controlled-vocabulary-schema">
		<sch:rule context = "schema">
			<sch:assert test = "count(*) = count(simpleType[@name])">The schema must contain only a single simple type definition.</sch:assert>
			<sch:assert test = "count(simpleType[@name]) = 1">The schema must contain a single simpleType definition or a single include.</sch:assert>
		</sch:rule>
		<sch:rule context = "simpleType">
			<sch:assert test = "@name">The simpleType must have a name.</sch:assert>
			<sch:assert test = "count(restriction) = 1">The simpleType must contain a single restriction.</sch:assert>
			<sch:assert test = "count(*) = count(annotation)+count(restriction)">The simpleType may have an annotation as well as its restriction, but no other structure.</sch:assert>
		</sch:rule>
		<sch:rule context = "restriction">
			<sch:assert test = "enumeration">A restriction must contain enumerated values.</sch:assert>
		</sch:rule>
		<sch:rule context = "enumeration">
			<sch:key name = "enumerationsByValue" path = "@value"/>
			<sch:assert test = "count(key('enumerationsByValue', @value)) = 1">An enumerated value must be unique.</sch:assert>
		</sch:rule>
	</sch:pattern>
</sch:schema>